var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
export function yupValidator(yupSchema, options, messageTransformer) {
    return (values) => __awaiter(this, void 0, void 0, function* () {
        try {
            yield yupSchema.validate(values, options);
            return {};
        }
        catch (ex) {
            return yupErrorToErrorMap(ex, messageTransformer !== null && messageTransformer !== void 0 ? messageTransformer : ((e) => e));
        }
    });
}
export function yupErrorToErrorMap(error, errorTransformer) {
    let errors = error.path ? [error] : error.inner;
    let obj = {};
    for (let i = 0; i < errors.length; i++) {
        let err = errors[i];
        if (!err.path || !err.message)
            continue;
        let pathSegments = Array.from(err.path.matchAll(/(\w+)/gi)).map((e) => e[0]);
        let o = obj;
        for (let j = 0; j < pathSegments.length; j++) {
            let key = pathSegments[j];
            let oo = o[key];
            if (!oo) {
                oo = {};
                o[key] = oo;
            }
            if (j === pathSegments.length - 1) {
                o[key] = errorTransformer(err.message);
            }
            else {
                o = oo;
            }
        }
    }
    return obj;
}
